import { timerify } from '../../util/Performance.js';
import { hasDependency, load } from '../../util/plugin.js';
const NAME = 'cspell';
const ENABLERS = ['cspell'];
const isEnabled = ({ dependencies }) => hasDependency(dependencies, ENABLERS);
const CONFIG_FILE_PATTERNS = [
    'cspell.config.{js,cjs,json,yaml,yml}',
    'cspell.{json,yaml,yml}',
    '.c{s,S}pell.json',
    'cSpell.json',
];
const findCspellDependencies = async (configFilePath, { isProduction }) => {
    if (isProduction)
        return [];
    const localConfig = await load(configFilePath);
    if (!localConfig)
        return [];
    const imports = localConfig.import ?? [];
    return imports;
};
const findDependencies = timerify(findCspellDependencies);
export default {
    NAME,
    ENABLERS,
    isEnabled,
    CONFIG_FILE_PATTERNS,
    findDependencies,
};
