import { timerify } from '../../util/Performance.js';
import { hasDependency, load } from '../../util/plugin.js';
import { findVitestDependencies } from '../vitest/index.js';
const NAME = 'Vite';
const ENABLERS = ['vite'];
const isEnabled = ({ dependencies }) => hasDependency(dependencies, ENABLERS);
export const CONFIG_FILE_PATTERNS = ['vite*.config.{js,mjs,ts,cjs,mts,cts}'];
const findViteDependencies = async (configFilePath, options) => {
    const localConfig = await load(configFilePath);
    if (!localConfig)
        return [];
    return findVitestDependencies(configFilePath, localConfig, options);
};
const findDependencies = timerify(findViteDependencies);
export default {
    NAME,
    ENABLERS,
    isEnabled,
    CONFIG_FILE_PATTERNS,
    findDependencies,
};
